#include "stdafx.h"
#include "dllmain.h"
#include <math.h>
#include <TCHAR.H>

/**
 */
BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			TCHAR* str = "DLL_PROCESS_ATTACH\n";
			WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (const void*) str, _tcslen(str), 0, NULL);
			
			// TODO: Place any initialization code (for this plugin) to execute on SIMPHYNITY startup here...
		}
		break;

	case DLL_PROCESS_DETACH:
		{
			TCHAR* str = "DLL_PROCESS_DETACH\n";
			WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (const void*) str, _tcslen(str), 0, NULL);
		
			// TODO: Place any destruction code (for this plugin) to execute on SIMPHYNITY destruction here...
		}
		break;

	default:
		break;
	}

	return TRUE;
}

/**
 */
DECLDIR void GetDefaultSettings(const GAME_SETTINGS* settings)
{
	GAME_SETTINGS* gs = (GAME_SETTINGS*) settings;
	gs->maxGs = 2.0f;
	gs->maxSpeed = 200.0f;
	gs->displaySpeedUnits = DISPLAY_SPEED_UNITS_MPH;
	gs->learnSpeed = false;
	gs->accelScalar = -1;
}

/**
 */
DECLDIR int GetNumExeNames()
{
	return 1;
}

/**
 */
DECLDIR void GetExeName(int index, const TCHAR* exeName)
{
	static TCHAR* names[1] = 
	{
		 _T("F1_2011.exe"),
	};

	_tcscpy((TCHAR*) exeName, names[index]);
}

/**
 */
DECLDIR int GetNumParentDirs()
{
	return 0;
}

/**
 */
DECLDIR void GetParentDir(int index, const TCHAR* dir)
{
	static TCHAR* dirs[1] = 
	{
		 _T("MyGame")
	};

	_tcscpy((TCHAR*) dir, dirs[index]);
}

/**
 */
DECLDIR void GetSimphyintyRemoteSettings(const REMOTE_CONFIG* settings)
{
	REMOTE_CONFIG* srs = (REMOTE_CONFIG*) settings;

	// TODO: Configure Simphynity remote settings here...
	srs->enabled = true;
}

/**
 */
DECLDIR void OnGameDetected()
{
	// TODO: Perform any actions required upon game detection here...
}

/**
 */
DECLDIR void OnGameLost()
{
	// TODO: Perform any actions required upon game undetection here...
}

/**
 */
DECLDIR void GetTelemetryData(const TELEMETRY_DATA* telem)
{
	TELEMETRY_DATA* t = (TELEMETRY_DATA*) telem;
	
	// Example.  TODO: Replace with own teletry code...
	
	static const float ONE_G_MS = 9.80665f;	
	static const float MPH_TO_MS = 0.45f;

	t->useLocalVals = true;

	static float cnt = 0.0f;
	
	t->localVel[0] = (50.0f + (50.0f * sin(cnt))) * MPH_TO_MS; // Accelerate to 100mph and back again.
	t->localVel[1] = 0.0f;
	t->localVel[2] = 0.0f;

	t->localAccel[0] = -(ONE_G_MS * sin(cnt)); // Cycle acceleration / braking (1G each direction).
	t->localAccel[1] = 0;
	t->localAccel[2] = ONE_G_MS; // World gravity.

	cnt += 0.05f;
}
